/*
 *
 * Note.java
 *
 * Class defines what will be in a configuration file for a user note. All metadata is in this class when read from file
*/

package jesse.keeblarcraft.JsonClassObjects;

import java.util.HashMap;
import java.util.Map.Entry;

import jesse.keeblarcraft.ConfigMgr.ConfigManager;

public class PlayerNote {

    // Internal class structure that defines a blank note. It represents the overall loaded json object
    public class NoteFile {
        public String uuid;

        // Integer = note id
        // String  = note
        public HashMap<Integer, String> noteMap = new HashMap<Integer, String>();
    }

    NoteFile thisNote = new NoteFile();
    ConfigManager config = new ConfigManager();

    public PlayerNote(String uuid) {
        /// TODO: Below code needs to be tested first
        thisNote = (NoteFile) config.GetJsonObjectFromFile(uuid, uuid, NoteFile.class);
    }

    public void AddNote(String newNote) {
        Integer noteKey = thisNote.noteMap.size() + 1;
        thisNote.noteMap.put(noteKey, newNote);
    }

    public void DeleteNote(Integer noteId) {
        thisNote.noteMap.remove(noteId);
    }

    public void ModifyNote(Integer noteId, String newNote) {
        thisNote.noteMap.put(noteId, newNote);
    }

    // Find the key of a note if it exists (O(n) search time)
    // Returns -1 on failure to find note key
    public Integer GetNoteKey(String note) {
        Integer ret = -1;
        for (Entry<Integer, String> entry : thisNote.noteMap.entrySet()) {
            if (entry.getValue().equals(note)) {
                ret = entry.getKey();
            }
        }

        return ret;
    }
}
